

   if {![namespace exists ::FEBEX]} {namespace eval ::FEBEX {;#puts "created namespace ::FEBEX"}}

   if {![info exists ::FEBEX::ModuleMenu]} {set ::FEBEX::ModuleMenu [list localhost]}
   if {![info exists ::FEBEX::FEBEXHost]} {set ::FEBEX::FEBEXHost [first $::FEBEX::ModuleMenu]}

   if {![info exists ::FEBEX::TestMode]} {set rc [catch {set ::FEBEX::TestMode 0} m]}

    variable Rmsg ""
    variable Wmsg ""

    proc ReadFEBEXRegister {Addr}  {
        global errorCode errorInfo
        global MIDAS_XFEBEXAccessServer_Exists
        global XFEBEXAccessServerHost

# puts "ReadFEBEXRegister  Addr=[format \"0x%x\" $Addr]"
# return 0

  if {$::FEBEX::TestMode != 0} {
     variable FEBEXData
     if {![info exists FEBEXData($Addr)]} {set FEBEXData($Addr) 0xaaaa} 
     return [set FEBEXData($Addr)]
  }

        if {[info exists MIDAS_XFEBEXAccessServer_Exists]} {
# puts "ReadFEBEXRegister do_Get"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XFEBEXAccessServer do_Get $Addr} m]
        } else {
            if {$XFEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set XFEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "ReadFEBEXRegister configure $XFEBEXAccessServerHost"
                XFEBEXAccessClient_Configure
            }
# puts "ReadFEBEXRegister  $XFEBEXAccessServerHost  XFEBEXAccessClient__Get"
            set rc [catch {XFEBEXAccessClient__Get $Addr} m]
        }
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
#  puts "ReadFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#           InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#  puts "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc WriteFEBEXRegister {Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XFEBEXAccessServer_Exists
        global XFEBEXAccessServerHost

# puts "WriteFEBEXRegister  Vl=[format \"0x%x\" $Vl]  Addr=[format \"0x%x\" $Addr]"
# return 0

  if {$::FEBEX::TestMode != 0} {
     variable FEBEXData
     set FEBEXData($Addr) $Vl
     return
  }

        if {[info exists MIDAS_XFEBEXAccessServer_Exists]} {
# puts "WriteFEBEXRegister do_Set"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XFEBEXAccessServer do_Set $Addr $Vl} m]
        } else {
            if {$XFEBEXAccessServerHost != $::FEBEX::FEBEXHost} {
                set XFEBEXAccessServerHost  $::FEBEX::FEBEXHost
# puts "WriteFEBEXRegister configure $XFEBEXAccessServerHost"
                XFEBEXAccessClient_Configure
            }
# puts "WriteFEBEXRegister XFEBEXAccessClient__Set"
            set rc [catch {XFEBEXAccessClient__Set $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            puts "WriteFEBEXRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "WriteFEBEXRegister Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }





